 --Disable the addon if the player is not a hunter:
if select(2, UnitClass("player")) ~= "HUNTER" then
	return DisableAddOn("EZaspect+")
end
------------------------------------------------------------------------
-- Create the base frame:
local EZaspect = CreateFrame("Frame", "EZaspect", UIParent)
EZaspect:SetPoint("CENTER", -1, -144)
EZaspect:SetSize(180, 55)
-- Make it draggable and resizable:
EZaspect:SetMovable(true)
EZaspect:SetResizable(true)
EZaspect:EnableMouse(true)
EZaspect:SetMaxResize(180, 100)
EZaspect:SetMinResize(180, 35)
--EZaspect:RegisterEvent("PLAYER_LOG_IN")
EZaspect:RegisterForDrag("RightButton", "LeftButton")
EZaspect:SetScript("OnMouseDown", function(self, button)
local shiftDown = IsShiftKeyDown();
  if button == "RightButton" and not self.isMoving then
   self:StartMoving();
   self.isMoving = true;
  elseif ( IsShiftKeyDown() ) and (button == "LeftButton" and not self.isSizing) then
   self:StartSizing();
   self.isSizing = true
  end
end)
EZaspect:SetScript("OnMouseUp", function(self, button)
  if button == "RightButton" and self.isMoving then
   self:StopMovingOrSizing();
   self.isMoving = false; 
  elseif (button == "LeftButton" and self.isSizing) then
   self:StopMovingOrSizing();
   self.isSizing = false
  end
end)
EZaspect:SetScript("OnHide", function(self)
  if ( self.isMoving ) or (self.isSizing) then
   self:StopMovingOrSizing();
   self.isMoving = false;
   self.isSizing = false;
  end
end)
-- Add the background:
EZaspect:SetBackdrop({
    --bgFile = [[Interface\AddOns\EZaspect+\Icon\kentuckylongrifle2.tga]], tile = False, tileSize = 32,
	bgFile = [[Interface\Icons\ability_ensnare]], tile = false, tileSize = 0,
	edgeFile = [[Interface\DialogFrame\UI-DialogBox-Border]], edgeSize = 32,
	insets = { left = 16, right = 17, top = 17, bottom = 16,}
})
EZaspect:SetBackdropColor(0.5,0.5,0.5,0.50)
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
-- Set up a button factory:
local CreateTrapButton
do
-- Share the same event handler function between buttons
-- instead of creating duplicate functions:
	    local function TrapButton_OnEvent(self, event, ...)
		local start, duration = GetSpellCooldown(self.spellID)
		if duration > 0 then
			self.cooldown:Show()
			self.cooldown:SetCooldown(start, duration)
		end
	end
	function CreateTrapButton(spellID)
-- Get the name and icon for the specified spell:
		local spellName, _, spellIcon = GetSpellInfo(spellID)
		if not spellName then
			-- That's not a valid spell ID!
			return
		end		
-- Create the button:
		local button = CreateFrame("Button", "$parent"..gsub(spellName, "[^%a]", ""), EZaspect, "SecureActionButtonTemplate")		
-- Set the correct trap spell properties:
		button:SetAttribute("type", "spell")
		button:SetAttribute("spell", spellName)
		button:SetNormalTexture(spellIcon)
		button.spellID = spellID
-- Add a cooldown to the button:
		local cd = CreateFrame("Cooldown", "$parentCooldown", button, "CooldownFrameTemplate")
		button.cooldown = cd
		cd:SetAllPoints(true)
		cd:Hide()
-- Update the cooldown when needed:
		button:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		button:SetScript("OnEvent", TrapButton_OnEvent)
-- Hand the button back to the calling code:
		return button
	end
end
------------------------------------------------------------------------------------------------------	
local z = CreateFrame("Frame", "EZListen", UIParent)
z:RegisterEvent("PLAYER_ENTERING_WORLD")
z:SetScript("OnEvent", function(self, event, ...) return self[event](self, event, ...) end)
function z:PLAYER_ENTERING_WORLD()

--Add button for Cheetah
local level = UnitLevel("player")
local name ASPECT_OF_THE_CHEETAH = GetSpellInfo(5118)
local Cheetah = CreateTrapButton(5118)
Cheetah:ClearAllPoints()
Cheetah:SetPoint("TOPLEFT", EZaspect, 10, -10, "TOPRIGHT", Pack)
Cheetah:SetPoint("BOTTOMLEFT", EZaspect,  10, 10)
Cheetah:SetSize(32, 32)
Cheetah:RegisterUnitEvent("UNIT_AURA", "player")
Cheetah:SetScript("OnEvent", function()
   local name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff("player", ASPECT_OF_THE_CHEETAH)
   if name then
      -- Cheetah:SetNormalTexture([[Interface\Icons\spell_nature_wispsplode]])
	   Cheetah:SetNormalTexture([[Interface\Icons\Spell_nature_wispsplodegreen]])
   elseif not name then
       Cheetah:SetNormalTexture([[Interface\Icons\ability_mount_jungletiger]])
   end
end)
	if level < 24 then
		Cheetah:Hide()
	else
		Cheetah:Show()
	end
------------------------------------------------------------------------------------------------------
local name ASPECT_OF_THE_PACK = GetSpellInfo(13159)
local Pack = CreateTrapButton(13159)
Pack:ClearAllPoints()
Pack:SetPoint("TOPLEFT", Cheetah, "TOPRIGHT", Feign)
Pack:SetPoint("BOTTOMLEFT", Cheetah, "BOTTOMRIGHT", Feign)
Pack:SetSize(32, 32)
Pack:RegisterUnitEvent("UNIT_AURA", "player")
local function Pack_OnEvent(self, event, ...)
local start, duration = GetSpellCooldown(13159)
		if duration > 0 then
			self.cooldown:Show()
			self.cooldown:SetCooldown(start, duration)
		end
Pack:SetScript("OnEvent", function()
   local name, _, _, _, _, _, _, _, _, _, spellID = UnitBuff("player", 

ASPECT_OF_THE_PACK)
   if name then
       Pack:SetNormalTexture([[Interface\Icons\spell_nature_wispsplode]])
   elseif not name then
       Pack:SetNormalTexture([[Interface\Icons\ability_mount_whitetiger]])
   end
end)
-- Add a cooldown to the button:
		local cd = CreateFrame("Cooldown", "$parentCooldown", Pack, 

"CooldownFrameTemplate")
		Pack.cooldown = cd
		cd:SetAllPoints(true)
		cd:Hide()
-- Update the cooldown when needed:
		Pack:RegisterEvent("SPELL_UPDATE_COOLDOWN")
		Pack:SetScript("OnEvent", Pack_OnEvent)
end
if level < 56 then
    Pack:Hide()
  else
    Pack:Show()
  end
--Add a button for Feign Death:
local Feign = CreateTrapButton(5384)
Feign:ClearAllPoints()
Feign:SetPoint("TOPLEFT", Pack, "TOPRIGHT", Camo)
Feign:SetPoint("BOTTOMLEFT", Pack, "BOTTOMRIGHT", Camo )
Feign:SetSize(32, 32)

 --Add a button for Camouflage:
local Camo = CreateTrapButton(51753)
Camo:ClearAllPoints()
Camo:SetPoint("TOPLEFT", Feign, "TOPRIGHT", Fox)
Camo:SetPoint("BOTTOMLEFT", Feign, "BOTTOMRIGHT", Fox)
Camo:SetSize(32, 32)
if level < 85 then
    Camo:Hide()
  else
    Camo:Show()
  end

  --Add a button for Aspect of the Fox:
local Fox = CreateTrapButton(172106)
Fox:ClearAllPoints()
Fox:SetPoint("TOPLEFT", Camo, "TOPRIGHT", EZaspect, 0, 0)
Fox:SetPoint("BOTTOMLEFT", Camo, "BOTTOMRIGHT", EZapsect, 0, 0)
Fox:SetSize(32, 32)
if level < 84 then
    Fox:Hide()
  else
    Fox:Show()
  end
end
------------------------------------------------------------------------------------------------------

